<?php

namespace Drupal\entity_mesh\Batches;

use Drupal\node\NodeInterface;

/**
 * Batch for nodes.
 */
class NodeBatch implements BatchInterface {

  /**
   * {@inheritdoc}
   */
  public static function getItemsForOperation() {
    $nids = \Drupal::entityTypeManager()
      ->getStorage('node')
      ->getQuery()
      ->accessCheck()
      ->execute();
    return $nids;
  }

  /**
   * {@inheritdoc}
   */
  public static function operation($id, $count, $num_item, &$context) {
    $node = \Drupal::entityTypeManager()
      ->getStorage('node')
      ->load($id);
    if ($node instanceof NodeInterface) {
      \Drupal::service('entity_mesh.entity_render')->processEntity($node);
    }

    $context['results'][] = $id;
    $context['message'] = t('Running Batch "@count|@num_item" (node)',
      ['@count' => $count, '@num_item' => $num_item]
    );
  }

  /**
   * {@inheritdoc}
   */
  public static function clearEntityMesh() {
    \Drupal::service('entity_mesh.repository')->deleteSourceByType('entity_render', ['source_entity_type' => 'node']);
  }

}
